unit couleurs_f;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IniFiles;

type
  TFormCouleurs = class(TForm)
    Label1: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Label2: TLabel;
    ColorDialog: TColorDialog;
    Button1: TButton;
    Button2: TButton;
    ButtonOk: TButton;
    ButtonAnnuler: TButton;
    Label0: TLabel;
    Shape0: TShape;
    Button0: TButton;
    ButtonAppliquer: TButton;
    ShapeFond: TShape;
    LabelFond: TLabel;
    ButtonFond: TButton;
    ButtonReinitialiser: TButton;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonReinitialiserClick(Sender: TObject);
    procedure ButtonFondClick(Sender: TObject);
    procedure ButtonAppliquerClick(Sender: TObject);
    procedure ButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
  private
    IniFile : TIniFile;
  public
    { Dclarations publiques }
  end;

var
  FormCouleurs: TFormCouleurs;

implementation

uses main_f, basep4;

{$R *.dfm}

const
  stShape           : String = 'Shape';
  stSectionCouleurs : String = 'Couleurs';
  stEntreeFond      : String = 'Fond';
  stEntreePlateau   : String = 'Plateau';
  stEntreeJoueur1   : String = 'Joueur1';
  stEntreeJoueur2   : String = 'Joueur2';

procedure TFormCouleurs.ButtonOkClick(Sender: TObject);
var i : TCase;
begin
FormMain.Color:=ShapeFond.Brush.Color;
for i:=Low(TCase) to High(TCase) do
  Couleur[i]:=(FindComponent(stShape+IntToStr(Ord(i))) as TShape).Brush.Color;
with IniFile do
  begin
  WriteInteger(stSectionCouleurs, stEntreeFond, ShapeFond.Brush.Color);
  WriteInteger(stSectionCouleurs, stEntreePlateau, Shape0.Brush.Color);
  WriteInteger(stSectionCouleurs, stEntreeJoueur1, Shape1.Brush.Color);
  WriteInteger(stSectionCouleurs, stEntreeJoueur2, Shape2.Brush.Color);
  end{with}
end;

procedure TFormCouleurs.FormShow(Sender: TObject);
var i : TCase;
begin
ShapeFond.Brush.Color:=FormMain.Color;
for i:=Low(TCase) to High(TCase) do
  (FindComponent(stShape+IntToStr(Ord(i))) as TShape).Brush.Color:=Couleur[i];
end;

procedure TFormCouleurs.ButtonClick(Sender: TObject);
var Joueur : TCase;
begin
Joueur:=TCase((Sender as TButton).Tag);
ColorDialog.Color:=Couleur[Joueur];
if ColorDialog.Execute then
  (FindComponent(stShape+IntToStr(Ord(Joueur))) as TShape).Brush.Color:=ColorDialog.Color;
end;

procedure TFormCouleurs.ButtonAppliquerClick(Sender: TObject);
begin
ButtonOkClick(Sender);
FormMain.RedessinePlateau;
end;

procedure TFormCouleurs.ButtonFondClick(Sender: TObject);
begin
ColorDialog.Color:=FormMain.Color;
if ColorDialog.Execute then
  ShapeFond.Brush.Color:=ColorDialog.Color;
end;

procedure TFormCouleurs.ButtonReinitialiserClick(Sender: TObject);
begin
  ShapeFond.Brush.Color:=clBlack;
  Shape0.Brush.Color:=clBlue;
  Shape1.Brush.Color:=clYellow;
  Shape2.Brush.Color:=clRed;
end;

procedure TFormCouleurs.FormCreate(Sender: TObject);
begin
IniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'FP4.ini');
with IniFile do
  begin
  ShapeFond.Brush.Color:=IniFile.ReadInteger(stSectionCouleurs, stEntreeFond, clBlack);
  Shape0.Brush.Color:=IniFile.ReadInteger(stSectionCouleurs, stEntreePlateau, clBlue);
  Shape1.Brush.Color:=IniFile.ReadInteger(stSectionCouleurs, stEntreeJoueur1, clYellow);
  Shape2.Brush.Color:=IniFile.ReadInteger(stSectionCouleurs, stEntreeJoueur2, clRed);
  end{with};
ButtonOkClick(Sender); // On applique les couleurs lues  la cration
end;

procedure TFormCouleurs.FormDestroy(Sender: TObject);
begin
if IniFile<>nil then FreeAndNil(IniFile);
end;

end.
